
                          4DOS License and Order Form

                             Version 3.02, 9/7/90


   Copyright 1989, 1990, J.P. Software.  All Rights Reserved.  Published by
   J.P. Software, P.O. Box 1470, E. Arlington, MA 02174 USA, (617) 646-
   3975.

   This file, ORDER.FRM, contains the 4DOS license agreement, and gives you
   information on registering 4DOS.  The actual registration form is at the
   end of the file.  There is also a separate form for registered users of
   an earlier version of 4DOS who wish to upgrade to version 3.02.

   J.P. Software offers an add-on product for registered 4DOS users only,
   the 4DOS Utility Disk, priced at $10 plus shipping.  This disk includes
   the files you need if you want to modify the 4DOS help text, and several
   useful freeware or shareware utilities.  See the last page of README.DOC
   for a complete description of the utility disk's contents.

   You can print this file by COPYing it to your printer with the following
   command:

          copy order.frm prn

   The file already contains form feeds and page footers, so attempting to
   print it with a program that formats the pages may not work.  Page
   length has been set to 58 lines so the file should print properly on
   laser printers.

   If you live outside the US and Canada please check the list of interna-
   tional dealers below.  Purchasing through these dealers can save you the
   delay and inconvenience which may be involved in dealing with currency
   conversions and international shipping.  Please contact the dealer
   closest to you for pricing and delivery information.  All of these
   dealers carry registered copies of the latest version of 4DOS.


      England:           Shareware Marketing      voice:  (0297) 24088
                         Beer EX12 3HW            fax:    (0297) 24091

      West Germany:      Computer Solutions       voice:  (08) 092-5018
                         Gartenstr. 2 / Postfach  fax:    (08) 092-31727
                         0818 Grafing

                         Kirschbaum Software      voice:  (08) 067-1016
                         Kronaustr. 15            fax:    (08) 067-1053
                         8091 Emmerling

      Australia:         Manaccom Pty Ltd.        voice:  (07) 368-2366
                         P. O. Box 509            fax:    (07) 369-7589
                         Kenmore QLD 4069



   4DOS 3.02  [9-7-90]             ORDER.FRM                         page 1

   Registration Information
   ------------------------

   4DOS is a copyrighted program protected by both U.S. and international
   copyright law.  If you obtained 4DOS from a shareware disk vendor, an
   on-line computer service or bulletin board, a friend or colleague, or
   another similar source, you have an unregistered (trial) copy.  You may
   use this copy without charge for a limited period of time under the
   terms of the 4DOS license agreement (below).  After this time is up, you
   must register and pay for 4DOS to continue using it.

   This method of distribution is known as shareware.  It allows you to
   determine whether 4DOS meets your needs before you pay for it.

   The registration fee for a single copy of 4DOS is $50.  Payment of this
   fee entitles you to:

      * A disk with the latest version of 4DOS, registered to you.

      * One copy of the printed and bound 4DOS manual.

      * An upgrade to the next major release of 4DOS.
          (Both major upgrades and maintenance releases will be available
          for downloading from a wide variety of sources.  If you need an
          upgrade on diskette there will be a minimal processing charge to
          cover our costs in sending it to you.)

      * Technical support via electronic mail or telephone.

      * A subscription to the 4DOS newsletter.

   If you prefer, you may register for $35 and receive only the disk and
   notices of future upgrades.  Network, site, and corporate licenses are
   also available; contact J.P. Software for more information.

   If you purchased a complete copy of 4DOS with printed manual from a
   software dealer, your copy came with a yellow registration card.  Return
   this card promptly to J.P. Software to ensure you are registered with
   us, and to receive technical support and notices of future upgrades.  If
   you purchased 4DOS directly from J.P. Software and paid the full $35 or
   $50 fee, you are already registered, and no registration card is neces-
   sary.


   Upgrade Information
   -------------------

   If you purchased 4DOS version 2.1 or later at the $50 rate, or a site
   license for version 2.1 or later, you are entitled to a free upgrade to
   version 3.02.  Follow the instructions in README.DOC for installing this
   shareware copy of 4DOS version 3.01 and converting it to a registered
   copy.  If you are not entitled to a free upgrade, or you wish to order a
   version 3 manual or a copy of the 4DOS utility disk, use the order form
   below.


   4DOS 3.02  [9-7-90]             ORDER.FRM                         page 2


   4DOS License Agreement
   ----------------------

   (1)  Copyright:  The 4DOS program and all other programs and documenta-
   tion distributed or shipped with it are Copyright Rex C.  Conn and J.P.
   Software, 1988, 1989, 1990, or are distributed under license to J.P.
   Software, and are protected by U.S. and international copyright law.  In
   the rest of this document, this collection of programs is referred to
   simply as "4DOS".  You are granted a license to use your copy of 4DOS
   only under the terms and conditions specified in this license agreement.

   (2)  Definitions:  4DOS is distributed in two forms.  A "registered"
   copy of 4DOS is a copy distributed on diskette, purchased from J.P.
   Software or from a dealer, and which includes a serial number and the
   legend "licensed" or "registered" in the program sign-on message and on
   the diskette label.  A "shareware" copy of 4DOS is a copy distributed on
   diskette or via an electronic bulletin board, on-line service, or other
   electronic means, obtained from a shareware disk vendor, or obtained
   from another individual, and which displays the legend "shareware" in
   the program sign-on message, and in most cases on the diskette label as
   well (if applicable).

   (3)  Shareware Copies:  Shareware copies of 4DOS are distributed to
   allow you to try the program before you pay for it.  They are Copyright
   1989, 1990, Rex C. Conn and J.P. Software, and do not constitute "free"
   or "public domain" software.  You may use a shareware copy of 4DOS at no
   charge for a trial period of up to 21 days.  If you wish to continue
   using 4DOS after that period, you must purchase a registered copy.  If
   you choose not to purchase a registered copy, you must stop using 4DOS,
   though you may keep copies and pass them along to others.

   (4)  Registered Copies:  Registered copies of 4DOS are distributed to
   those who have purchased them.  Your registered copy of 4DOS may only be
   used on the number of computers specified on the diskette label and
   program sign-on screen.

   (5)  Use of One Copy on Two Computers:  If you have a registered copy of
   4DOS which is licensed for use on a single computer, you may install it
   on two computers used at two different locations (for example, at work
   and at home), provided there is no possibility that the two computers
   will be in use at the same time, and provided that you yourself have
   purchased 4DOS, or if 4DOS was purchased by your employer, that you have
   your employer's explicit permission to install 4DOS on two systems as
   described in this paragraph.  The right to install one copy of 4DOS on
   two computers is limited to copies originally licensed for use on a
   single computer, and may not be used to expand the number of systems
   covered under a multi-system license.

   (6)  Use of 4DOS on Networks or Multiple Systems:  You may install your
   registered copy of 4DOS on a computer attached to a network, or remove
   it from one computer and install it on a different one, provided there
   is no possibility that your copy will be used by more users than it is
   licensed for.  A "user" is defined as one keyboard which is connected to


   4DOS 3.02  [9-7-90]             ORDER.FRM                         page 3

   a computer on which 4DOS is installed or used, regardless of whether or
   not the user of the keyboard is aware of the installation or use of 4DOS
   in the system.

   (7) Making Copies:  You may copy any version of 4DOS for normal backup
   purposes, and you may give copies of the shareware version to other
   individuals, which they may also use and copy subject to the terms of
   this agreement.  If you copy the shareware version of 4DOS for others,
   you must include all of the files distributed with it, including this
   one.  You may not give copies of the registered version to any other
   person for any purpose, and you may not make any copies of the printed
   and bound 4DOS manual without explicit written permission from J.P.
   Software.

   (8) Distribution Restrictions:  You may NOT distribute 4DOS other than
   through individual copies of the shareware version passed to friends and
   associates for their individual use.  Specifically, you may not place
   4DOS or any part of the 4DOS package in any user group or commercial
   library, or distribute it with any other product or as an incentive to
   purchase any other product, without express written permission from J.P.
   Software, and you may not distribute for a fee, or in any way sell
   copies of 4DOS or any part of the 4DOS package.  If you are a shareware
   disk vendor approved by the Association of Shareware Professionals
   (ASP), you may place 4DOS in your library without prior written permis-
   sion, provided you notify J.P. Software within 15 days of doing so; and
   provided your application has been fully approved in writing by the ASP,
   and is not simply submitted or awaiting review.

   (9)  Use of 4DOS:  4DOS is a powerful program.  While we have attempted
   to build in reasonable safeguards, if you do not use 4DOS properly you
   may destroy files or cause other damage to your computer software and
   data.  You assume full responsibility for the selection and use of 4DOS
   to achieve your intended results.  As stated below, J.P. Software limits
   its warranty to replacement of a defective program diskette or manual.

   (10) LIMITED WARRANTY:  J.P. Software warrants to owners of registered
   copies of 4DOS that the software will operate in accordance with the de-
   scription given in the documentation, and that the diskette and manual
   will be free of physical defects which interfere with normal use.  The
   software on the 4DOS Utility Disk which was not created by J.P. Soft-
   ware, as stated in the documentation provided on the disk, is not war-
   ranted to operate in accordance with its documentation, and is sold AS-
   IS AND WITHOUT WARRANTY OF ANY KIND BY J.P. SOFTWARE.  For a period of
   90 days from the date of your purchase of 4DOS, J.P. Software will, at
   its sole option and subject to the restrictions above and below, repair
   or replace any defective item(s), or refund the purchase price of any
   diskette and/or manual and/or any other parts or components of 4DOS
   found to be defective, if such defect is the fault of J.P. Software and
   not the result of misuse or abuse.  Such a refund, repair, or replace-
   ment shall be your sole remedy for any defects, program error(s), or
   documentation error(s).  In no event shall J.P. Software be responsible
   for any other costs or damages whatsoever due to errors in usage or your
   failure to read, understand, or follow instructions in the documenta-
   tion.  J.P. SOFTWARE MAKES NO OTHER WARRANTIES, EXPRESS OR IMPLIED,


   4DOS 3.02  [9-7-90]             ORDER.FRM                         page 4

   INCLUDING WITHOUT LIMITATION THE WARRANTIES OF MERCHANTABILITY AND OF
   FITNESS FOR A PARTICULAR PURPOSE.  J.P.  Software's warranty is express-
   ly limited to the cost of replacement of any defective diskette or other
   part.

   (11)  Satisfaction Guarantee:  If you are dissatisfied with a registered
   copy of 4DOS for any reason (whether or not you find a software error or
   defect), you may return the entire package at any time up to 90 days
   after purchase for a full refund of your original registration fee.















































   4DOS 3.02  [9-7-90]             ORDER.FRM                         page 5

   4DOS 3.02 Order Form            Return to:  J.P. Software
                                               P.O. Box 1470
                                               E. Arlington, MA 02174 USA

      Name ______________________________________________________________
      Company ___________________________________________________________
      Address ___________________________________________________________
              ___________________________________________________________
      Phone _____________________________________________________________

      Register 4DOS to:      ___ Company         ___ Individual
      Send information on:   ___ Site Licenses   ___ Reseller Pricing

      I have read and agree to abide by the 4DOS license agreement:

        (Signature) _____________________________________________________

      Where did you hear about 4DOS? ____________________________________


      Credit card orders:  MasterCard / Visa / American Express (circle
      one); $15 minimum.

      Card Number ______________________________________  Expires _______

      Exact name on card (print) ________________________________________

      Signature (REQUIRED) ______________________________________________

                                                       Quantity    Price

      Disk, manual, next update ($50/copy):            ________  $ ________
      Disk only, no update ($35/copy):                 ________  $ ________
      4DOS Utility Disk for registered users (see      ________  $ ________
          README.DOC for details, $10 each)

          Disk size:   ___ 5.25" acceptable   ___ 3.5" required

      Subtotal                                                   $ ________
      Sales tax (Massachusetts customers only,                   $ ________
          5% of above subtotal)

      Shipping charges, per copy:                      ________  $ ________
          Disk, manual, next update:  $4 US standard, $8 US
            2-day, $5 Canada (air), $10 all others (air).
          Disk only:  $2 US standard, $8 US 2-day, $3 Canada
            (air), $5 all others (air).
          Utility disk:  no shipping charge when ordered with
            registration.
          Contact us for charges on orders of 3 or more copies.

      Total enclosed:                                            $ ________

            ===>  Please read the next page before ordering!  <===


   4DOS 3.02  [9-7-90]             ORDER.FRM                         page 6

   Order Information
   -----------------

   Terms and Conditions:

      All credit card charges will be authorized; credit cards are not
      charged until your order is being shipped.  Personal checks may be
      subject to bank clearance delay before shipment.  All payments must
      be made in US funds and drawn on a US bank.

   Ordering 4DOS by Telephone, Electronic Mail, or Fax:

      To order by phone call us between 9:00 AM and 5:00 PM eastern U.S.
      time at 800-368-8777 (ORDERS ONLY please!) or 617-646-3975; or trans-
      mit your order form to us by fax at (617) 646-0904.  You can also
      order via CompuServe (Mail to 75300,210), Internet (75300.210@compu-
      serve.com), or BIX (mail to "trawson"); please include all informa-
      tion on the order form with your electronic order, preferably in the
      same format.  Telephone, fax, and electronic mail orders must be paid
      by credit card.

   International Orders:

      Orders from outside the U.S. must be paid by MasterCard, Visa, or
      American Express; by a check or money order in U.S. funds and drawn
      on a U.S. bank; or by an international postal money order in U.S.
      dollars.  Checks which are not in U.S. funds and drawn on a U.S. bank
      will be returned due to extremely high charges imposed by U.S. banks
      to collect the funds.  Purchase orders (minimum $200) can be accepted
      from outside the U.S., but you must contact us before ordering.

   Company Purchase Orders:

      Purchase orders for amounts of $100 and over are accepted from estab-
      lished U.S. companies; orders under $100 are accepted but must be
      prepaid.  Have your purchasing agent contact J.P. Software for terms. 
      Credit references will be required for new customers.

   Multi-System Licenses:

      Multi-system licensing arrangements are available for network, site,
      and corporate use of 4DOS.  Check the line on the order form or con-
      tact us for more information.  A sample schedule of license fees is
      below; contact us for pricing on the exact number of systems you wish
      to license.  The fee includes a master diskette and one manual; addi-
      tional manuals are $10 each (less for over 100 copies).

      Systems      Price      Systems      Price       Systems      Price
      -------    --------     -------    --------      -------    --------
          2         85.00        15        425.00         50      1,150.00
          3        120.00        20        550.00         60      1,160.00
          4        155.00        25        675.00         70      1,320.00
          5        190.00        30        750.00         80      1,480.00
         10        330.00        40        950.00        100      1,800.00


   4DOS 3.02  [9-7-90]             ORDER.FRM                         page 7

   4DOS 3.02 Upgrade Order Form    Return to:  J.P. Software
                                               P.O. Box 1470
                                               E. Arlington, MA 02174 USA

   NOTE:  This form is for use ONLY by registered 4DOS users ordering an
   upgrade or manual for version 3.02.  See page 6 above for new orders. 
   Please see the upgrade information on page 2 above if you are not sure
   whether you are entitled to a free upgrade.

      Name ______________________________________________________________
      Company ___________________________________________________________
      Address ___________________________________________________________
              ___________________________________________________________
      Phone _____________________________________________________________

      My copy of 4DOS is registered to (name): __________________________
      My 4DOS serial number is (REQUIRED): ______________________________


      Credit card orders:  MasterCard / Visa / American Express (circle
      one); $15 minimum.

      Card Number ______________________________________  Expires _______

      Exact name on card (print) ________________________________________

      Signature (REQUIRED) ______________________________________________

                                                       Quantity    Price

      Free upgrade version 2.1 or 2.2 to 3.02:         ________  $    0.00
      Purchased upgrade to version 3.02 ($12           ________  $ ________
          each, not including manual):
      Version 3 printed manual ($12 each):             ________  $ ________
      4DOS Utility Disk ($10 each):                    _______   $ ________

          Disk size:   ___ 5.25" acceptable   ___ 3.5" required

      Subtotal                                                   $ ________
      Sales tax (Massachusetts customers only,                   $ ________
          5% of above subtotal)

      Shipping charges, per copy:                      ________  $ ________
          No charge if the only item ordered is a free 
            upgrade, without manual.
          Orders including only a disk:  $2 US (first class
            mail), $3 Canada (air), $5 all others (air).
          Orders including a manual, with or without disk(s):
            $3 US standard, $8 US 2-day (UPS blue), $5 Canada
            (air), $10 all others (air)

      Total enclosed:                                            $ ________

          ===>  Please read the previous page before ordering!  <===


   4DOS 3.02  [9-7-90]             ORDER.FRM                         page 8

